<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <!-- <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('中文标题')" prop="titleZh">
        <el-input v-model="queryParams.titleZh" :placeholder="$t('请输入中文标题')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('英文标题')" prop="titleEn">
        <el-input v-model="queryParams.titleEn" :placeholder="$t('请输入英文标题')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('中文内容')" prop="contentZh">
        <el-input v-model="queryParams.contentZh" :placeholder="$t('请输入中文内容')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('英文内容')" prop="contentEn">
        <el-input v-model="queryParams.contentEn" :placeholder="$t('请输入英文内容')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="图片地址WEB" prop="bannerUrlWeb">
        <el-input v-model="queryParams.bannerUrlWeb" placeholder="请输入图片地址WEB" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="图片地址APP" prop="bannerUrlApp">
        <el-input v-model="queryParams.bannerUrlApp" placeholder="请输入图片地址APP" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="0显示 1不显示" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择0显示 1不显示" clearable size="small">
          <el-option :label="$t('请选择字典生成')" value="" />
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('创建时间')">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-:placeholder="$t('开始日期')" end-:placeholder="$t('结束日期')" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form> -->

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:banner:create']">{{$t('新增')}}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:banner:export']">{{$t('导出')}}</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="" align="center" prop="id" />
      <el-table-column :label="$t('标题')" align="center" prop="titleZh" />
      <el-table-column :label="$t('WEB端图片')" align="center" prop="bannerUrlWeb">
        <template slot-scope="scope">
          <el-image :src="scope.row.bannerUrlWeb"></el-image>
        </template>
      </el-table-column>
      <el-table-column :label="$t('APP端图片')" align="center" prop="bannerUrlApp" >
          <template slot-scope="scope">
          <el-image :src="scope.row.bannerUrlApp"></el-image>
        </template>
      </el-table-column>
      <el-table-column :label="$t('状态')" align="center" prop="status">
        <template slot-scope="scope">
          <span>{{ statusName(scope.row.status) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:banner:update']">{{$t('修改')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:banner:delete']">{{$t('删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="126px">
        <el-form-item :label="$t('中文标题')" prop="titleZh">
          <el-input v-model="form.titleZh" :placeholder="$t('请输入中文标题')" />
        </el-form-item>
        <el-form-item :label="$t('英文标题')" prop="titleEn">
          <el-input v-model="form.titleEn" :placeholder="$t('请输入英文标题')" />
        </el-form-item>
        <el-form-item :label="$t('中文内容')" prop="contentZh">
          <editor v-model="form.contentZh" :min-height="150"/>
        </el-form-item>
        <el-form-item :label="$t('英文内容')" prop="contentEn">
          <editor v-model="form.contentEn" :min-height="150"/>
        </el-form-item>
        <el-form-item :label="$t('WEB端广告图片（建议尺寸长*宽')+'1120*450）'" prop="bannerUrlWeb">
          <el-col :span="8">
            <el-input v-model="form.bannerUrlWeb" :placeholder="$t('请上传WEB端广告图片')" />
          </el-col>

          <el-upload action="#" :http-request="requestUpload" :show-file-list="false" :before-upload="beforeUploadWeb">
            <el-button size="small">
              {{$t('上传图片')}}
              <i class="el-icon-upload el-icon--right"></i>
            </el-button>
          </el-upload>
        </el-form-item>
        <el-form-item :label="$t('APP端广告图片（建议尺寸长*宽')+'675*304）'" prop="bannerUrlApp">
          <el-col :span="8">
            <el-input v-model="form.bannerUrlApp" :placeholder="$t('请上传APP端广告图片')" />
          </el-col>
         <el-upload action="#" :http-request="requestUpload" :show-file-list="false" :before-upload="beforeUploadApp">
            <el-button size="small">
              {{$t('上传图片')}}
              <i class="el-icon-upload el-icon--right"></i>
            </el-button>
          </el-upload>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{$t('确 定')}}</el-button>
        <el-button @click="cancel">{{$t('取 消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createBanner, updateBanner, deleteBanner, getBanner, getBannerPage, exportBannerExcel } from "@/api/ecw/banner";
import Editor from '@/components/Editor';
import { uploadFile } from "@/api/infra/file";
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import {CommonStatusEnum} from '@/utils/constants'

export default {
  name: "Banner",
  components: {
    Editor,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 广告设置列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        titleZh: null,
        titleEn: null,
        contentZh: null,
        contentEn: null,
        bannerUrlWeb: null,
        bannerUrlApp: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        titleZh: [{ required: true, message: this.$t("中文标题不能为空"), trigger: "blur" }],
        titleEn: [{ required: true, message: this.$t("英文标题不能为空"), trigger: "blur" }],
        bannerUrlWeb: [{ required: true, message: this.$t("web端广告图片不能为空"), trigger: "blur" }],
        bannerUrlApp: [{ required: true, message: this.$t("app端广告图片不能为空"), trigger: "blur" }]

      },
      CommonStatusEnum: CommonStatusEnum,
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),
    };
  },

  computed: {
    statusName() {
      return value => {
        for(let index in this.statusDictDatas) {
          let dictItem = this.statusDictDatas[index];
          if(dictItem.value == value) {
            return dictItem.value == CommonStatusEnum.ENABLE + '' ? this.$t('正常') : this.$t('禁用');
          }
        }
      }
    },
  },

  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getBannerPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        titleZh: undefined,
        titleEn: undefined,
        contentZh: undefined,
        contentEn: undefined,
        bannerUrlWeb: undefined,
        bannerUrlApp: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t("添加广告设置");
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getBanner(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t("修改广告设置");
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateBanner(this.form).then(response => {
            this.$modal.msgSuccess(this.$t("修改成功"));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createBanner(this.form).then(response => {
          this.$modal.msgSuccess(this.$t("新增成功"));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除广告设置编号为"') + id + this.$t('"的数据项?')).then(function() {
          return deleteBanner(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t("删除成功"));
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有广告设置数据项?')).then(() => {
          this.exportLoading = true;
          return exportBannerExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    },

    // 覆盖默认的上传行为
    requestUpload() {
    },
    // 上传预处理
    beforeUploadWeb(file) {
      if (file.type.indexOf("image/") == -1) {
        this.$modal.msgError(this.$t("文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件。"));
      } else {
        //上传
        let formData = new FormData();
        formData.append("file", file);
        // formData.append("path", this.uuid());
        uploadFile(formData).then(response => {
          this.$set(this.form, 'bannerUrlWeb', response.data);
          // this.form.img = response.data;
        })
      }
    },

    // 上传预处理
    beforeUploadApp(file) {
      if (file.type.indexOf("image/") == -1) {
        this.$modal.msgError(this.$t("文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件。"));
      } else {
        //上传
        let formData = new FormData();
        formData.append("file", file);
        // formData.append("path", this.uuid());
        uploadFile(formData).then(response => {
          this.$set(this.form, 'bannerUrlApp', response.data);
          // this.form.img = response.data;
        })
      }
    },

    uuid() {
      var s = [];
      var hexDigits = "0123456789abcdef";
      for (var i = 0; i < 36; i++) {
          s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
      }
      s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
      s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
      s[8] = s[13] = s[18] = s[23] = "-";

      var uuid = s.join("");
      return uuid;
    }
  }
};
</script>
